
package html;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class HtmlDocument 
{
	private Hashtable m_tags;	
	private URL m_url;	
	private StringBuffer m_code;
	public int nOpenTags;
	public int nCloseTags;
				
	
	public Hashtable getTagList(){
		return m_tags;
	}
	
	public URL getUrl(){
		return m_url;
	}
	
	public StringBuffer getStringBuffer(){
		return m_code;
	}
	
	
	public void Clear(){
       m_tags.clear();	
	   m_code.setLength(0);
	   nOpenTags=0;		
	   nCloseTags=0;
	}
		
	
	public HtmlDocument()		
	{
		m_tags=new Hashtable();
		m_code=new StringBuffer();
		nOpenTags=0;		
	    nCloseTags=0;
	}
	public HtmlDocument(String urlTarget)
		throws MalformedURLException
	{				
		this();
		setUrl(urlTarget);        
	}
	
	public HtmlDocument(URL urlTarget)
		throws MalformedURLException
	{		
		this();
		m_url=urlTarget;        
	}
	
	private void Parse()
		throws IOException,HtmlException
	{
		HtmlTokenizer tok = new HtmlTokenizer(m_code);
		HtmlTag tag = new HtmlTag();
		TagList Tlist;
		String s;
		nOpenTags=0;		
	    nCloseTags=0;
		
		while (tok.nextToken() != HtmlTokenizer.TT_EOF) 
			{
				int ttype = tok.getTokenType();
				if (ttype == HtmlTokenizer.TT_TAG){					
					tok.parseTag(tok.getStringValue(), tag);
					if (!tag.isEndTag ()){
						nOpenTags++;
						s=tag.getTagString().toLowerCase();
						Tlist=(TagList)m_tags.get(s);
						if (Tlist==null)
							Tlist= new TagList();
						Tlist.Add(tag);
						m_tags.put(s,Tlist);
					}
					else
						nCloseTags++;
				}
			}	
	}
	
	
	public void Load()
		throws IOException,HtmlException
	{	
		int c;
		m_code.setLength(0);
		InputStream inputstream=m_url.openStream();
		BufferedInputStream BIStream=new BufferedInputStream(inputstream);
		while ((c=BIStream.read())>-1)
			m_code.append((char)c);
		this.Parse();
	}	
	
	
	public void setUrl(String urlTarget)
		throws MalformedURLException
	{
			m_url=new URL(urlTarget);
	}
	
	public void setUrl(URL urlTarget)
		throws MalformedURLException
	{
			m_url=urlTarget;
	}
	
	public String  toString()
	{	  	  
	  return m_code.toString();
	}
}